# Input method editor (IME)


An input method (or input method editor, commonly abbreviated IME) is an operating system component or program that enables users to generate characters not natively available on their input devices by using sequences of characters (or mouse operations) that are available to them. Using an input method is usually necessary for languages that have more graphemes than there are keys on the keyboard. More info can be found on [wikipedia](https://en.wikipedia.org/wiki/Input_method) and with more info how to setup it and use here [wiki.archlinux](https://wiki.archlinux.org/title/Input_method)

## Example of emoji input in contour using ibus

List of emojis from [unicode](http://unicode.org/emoji/charts/full-emoji-list.html)

You can insert any unicode character using ibus IME by pressing Ctrl+Shift+u (default) and then insert unicode code for the emoji or other character.

![type:video](./ime/demo_ime.mp4)

## Example of input using pinyin via ibus

![type:video](./ime/pinyin_ime.mp4)
