# Contour Terminal Emulator

Contour is modern, fast, and designed for everyday use.
It's not just a terminal emulator, but a powerhouse of features tailored for those who seek efficiency and control. With GPU-accelerated rendering and high-DPI support, experience the smoothest and most responsive terminal emulator like never before.

Contour is designed with the advanced power user in mind, offering high-speed, feature-rich functionality across all major platforms. From Linux and OS/X to FreeBSD and Windows, we've got you covered. <br/>
Contour offers a suite of unique features designed to enhance your productivity and user experience. Enjoy support for font ligatures, emoji, and Unicode grapheme clusters. Navigate quickly with vertical line markers and vi-like input modes. Control your settings with runtime configuration reload and customizable key bindings. <br/>
Bring your terminal to life with color schemes, profiles, and sixel inline images. Enjoy the convenience of clickable hyperlinks, and set your clipboard with OSC 52.  <br/>

**This website is still in DRAFT mode, please be patient while we're building up the content.**

![screenshot showcasing notcurses ncneofetch on KDE/Fedora](screenshots/contour-notcurses-ncneofetch.png "Screenshot")

[Install](install.md){ .md-button .md-button--primary }
[Join :simple-discord: ](https://discord.gg/ncv4pG9){ .md-button .md-button--primary }


## Key Features

:material-check-bold:{.check-mark}  Available on all 4 major platforms, Linux, OS/X, FreeBSD, Windows. <br/>
:material-check-bold:{.check-mark}  [Font ligatures](demo/font-ligatures.md) support (very useful for programming and scripting) <br/>
![demo](/screenshots/contour-font-ligatures.png){ align=left }
:material-check-bold:{.check-mark}  Complex Unicode support, including colored Emoji (-: 🌈  💝  😛  👪  - including ZWJ, VS15, VS16 emoji :-) <br/>
:material-check-bold:{.check-mark}  [Vi-like input modes](input-modes.md) for improved navigation, selection and copy'n'paste experience <br/>
:material-check-bold:{.check-mark}  [Vertical Line Markers](demo/line-marks.md) (quickly jump to markers in your history!) <br/>
:material-check-bold:{.check-mark}  Profiles (grouped customization of: color scheme, login shell, and related behaviours) <br/>
:material-check-bold:{.check-mark}  [Sixel Image support](demo/images.md) <br/>
![sixel-index-demo](../screenshots/contour-sixel-plot.png){ align=left}
:material-check-bold:{.check-mark}  [VT320 Host-programmable and Indicator statusline support](demo/statusline.md) <br/>
:material-check-bold:{.check-mark}  Bold and italic fonts <br/>
:material-arrow-right:{.arrow-right-bold} [For a full list of features, click here](features.md) <br/>
